from smbus2 import SMBus
from ticlib import TicI2C, SMBus2Backend
from MM_Axis_class import Axis
from MM_system_info_class import DeviceInfo, SystemInfo
import paho.mqtt.client as mqtt
from MM_mqtt import topic_path_main, topic_path_control, topic_path_classification

#adresy driverů pro osu X
axis_x1_address = 10
axis_x2_address = 11
#adresy driverů pro osu Y
axis_y1_address = 20
axis_y2_address = 21
#adresy driverů pro osu Z
axis_z1_address = 30
axis_z2_address = 31

bus = SMBus(0)  # vytvoření instance pro sběrnici i2c -> reprezentuje /dev/i2c-0

#vytvoření instancí driverů jednotlivých os
axisX_m1 = TicI2C(SMBus2Backend(bus,axis_x1_address)) 
axisX_m2 = TicI2C(SMBus2Backend(bus,axis_x2_address))
axisY_m1 = TicI2C(SMBus2Backend(bus,axis_y1_address))
axisY_m2 = TicI2C(SMBus2Backend(bus,axis_y2_address))
axisZ_m1 = TicI2C(SMBus2Backend(bus,axis_z1_address))
axisZ_m2 = TicI2C(SMBus2Backend(bus,axis_z2_address))

#vytvoření instancí jednotlivých os
axis_X = Axis("AxisX", axisX_m1, axisX_m2)
axis_Y = Axis("AxisY", axisY_m1, axisY_m2)
axis_Z = Axis("AxisZ", axisZ_m1, axisZ_m2)

#vytvoření instancí pro globální komunikační kanály
system_info = SystemInfo()
device_info = DeviceInfo()

#inicializace dat v MQTT brokerovi, dle slovníku ve třídě axis, state_var
def mqtt_init_public(client: mqtt.Client):
    axis: Axis
    for axis in [axis_X, axis_Y, axis_Z]:
        for key, val in axis.state_var.items():
            var_topic = f'{topic_path_main}/{topic_path_control}/{topic_path_classification}/{axis.name}/{key}'
            client.publish(var_topic, val)

#inicializace dat v MQTT brokerovi, dle slovníku ve třídě axis, motors     
def mqtt_init_public_control(client: mqtt.Client):
    axis: Axis
    for axis in [axis_X, axis_Y, axis_Z]:
        for key, val in axis.motors.items():
            var_topic = f'{topic_path_main}/{topic_path_control}/{topic_path_classification}/{axis.name}/{key}'
            client.publish(var_topic, val)

if __name__ == '__main__':
    pass